## critterding 1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

IF (WIN32)
	SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
ENDIF (WIN32)




	# build type
			# 	set(CMAKE_BUILD_TYPE Release)
			# 	# compile option (Debug) 
			# 	set(CMAKE_CXX_FLAGS_DEBUG "-g -Og -Wall -Wextra -std=c++0x")
			# 	set(CMAKE_C_FLAGS_DEBUG "-g -Og -Wall -Wextra -std=c++0x")
			# 
			# 	# compile option (Release)
			# 	set(CMAKE_CXX_FLAGS_RELEASE "-W -Wall -Wextra -Ofast -std=c++0x")
			# 	set(CMAKE_C_FLAGS_RELEASE "-W -Wall -Wextra -Ofast -std=c++0x")




# 	SET(INSTALL_LIBS ON)
# 	add_definitions(-DINSTALL_LIBS=OFF)

# PROJECT ( lua )
# include_directories( dependencies/lua-5.1.4/src )
# add_subdirectory( dependencies/lua-5.1.4/src )



# 	PROJECT ( bullet )
	SET(BUILD_SHARED_LIBS OFF)
	SET(BUILD_CPU_DEMOS OFF)
	SET(BUILD_DEMOS OFF)
	SET(BUILD_EXTRAS OFF)
	SET(BUILD_MINICL_OPENCL_DEMOS OFF)
	SET(BUILD_MULTITHREADING OFF)
	SET(USE_GLUT OFF)
	SET(USE_DX11 OFF)
	SET(INSTALL_LIBS OFF)    # THIS DOESNT WORK THE FIRST TIME AFTER REMOVING CMAKECACHE, ALTERED BULLETS CMAKELISTS.TXT:783
# 	SET(INSTALL_EXTRA_LIBS OFF)

	include_directories( dependencies/bullet dependencies/bullet/src )
	add_subdirectory( dependencies/bullet )


# 	ADD_DEFINITIONS( " -Ldependencies/bullet/src/BulletCollision  -Bstatic -lLinearMath -lBulletMultiThreaded -lBulletDynamics -lBulletCollision" )
# 	ADD_DEFINITIONS( -Ldependencies/bullet/src/BulletCollision -Ldependencies/bullet/src/BulletMultiThreaded  )



# PROJECT ( boost )
# include_directories( dependencies/boost )
# PROJECT ( boost )
# include_directories( dependencies/boost dependencies/boost/boost )
# add_subdirectory( dependencies/boost/boost )

PROJECT(tinyxml)
include_directories(dependencies/tinyxml)
add_subdirectory(dependencies/tinyxml)

PROJECT(glew)
# IF(WIN32)
 add_definitions(-DGLEW_STATIC)
# ENDIF(WIN32)

include_directories(dependencies/glew)
add_subdirectory(dependencies/glew)



PROJECT ( bengine )

# # fmod
# SET(LIB_FMODLIBS "") 

FIND_PACKAGE ( OpenGL REQUIRED )
IF (OPENGL_FOUND)
  MESSAGE("OPENGL FOUND")
  MESSAGE(${OPENGL_LIBRARIES})
  SET(bengine_LIBS ${bengine_LIBS} ${OPENGL_LIBRARIES}) 
ELSE (OPENGL_FOUND)
  MESSAGE("OPENGL NOT FOUND")
ENDIF (OPENGL_FOUND)

# fmodex_vc.lib fmod_event.lib  QtGui4.lib QtOpenGL4.lib boost_bzip2.lib boost_iostreams.lib boost_filesystem.lib boost_system.lib 
# -DBOOST_ALL_NO_LIB   -DDOM_DYNAMIC
IF (WIN32)
  link_directories( ${CMAKE_SOURCE_DIR}/win32/lib )
  SET(bengine_WIN32LIBS SDLmain.lib SDL.lib SDL_net.lib SDL_image.lib freetype.lib ws2_32.lib  QtGui4.lib QtOpenGL4.lib ) 
  SET(bengine_WIN32INCL win32/include;src/utils/ftgl;src;dependencies;dependencies/qt/;dependencies/qt/QtOpenGL)
  add_definitions(-D__BT_SKIP_UINT64_H -D_USE_MATH_DEFINES -DFTGL_LIBRARY_STATIC -D_CRT_SECURE_NO_WARNINGS -DBOOST_FILESYSTEM_VERSION=3  )
ENDIF (WIN32)

IF (UNIX)

	add_definitions(-DUNIX -std=c++0x -DBOOST_FILESYSTEM_VERSION=3 -Wl,-Bstatic ) # -DGLEW_STATIC 
# 	ADD_DEFINITIONS( "  -rdynamic -Ldependencies/bullet/src/BulletSoftBody -Ldependencies/bullet/src/BulletDynamics -Ldependencies/bullet/src/BulletCollision -Ldependencies/bullet/src/LinearMath -Wl,-Bstatic -lBulletSoftBody -lBulletDynamics -lBulletCollision -lLinearMath" )


# 	IF ( DISABLE_FMOD )
# 	ELSE ( DISABLE_FMOD )
# 		# 32 BIT
# 		FIND_LIBRARY( LIB_FMODEX NAMES libfmodex.so )
# 		IF (LIB_FMODEX)
# 		MESSAGE("FMODEX FOUND")
# 		MESSAGE(${LIB_FMODEX})
# 		SET(LIB_FMODLIBS ${LIB_FMODLIBS} ${LIB_FMODEX}) 
# 		ELSE (LIB_FMODEX)
# 			# 64 BIT
# 			FIND_LIBRARY( LIB_FMODEX64 NAMES libfmodex64.so )
# 			IF (LIB_FMODEX64)
# 				MESSAGE("FMODEX FOUND")
# 				MESSAGE(${LIB_FMODEX64})
# 				SET(LIB_FMODLIBS ${LIB_FMODLIBS} ${LIB_FMODEX}) 
# 			ELSE (LIB_FMODEX64)
# 				MESSAGE("FMODEX NOT FOUND")
# 			ENDIF (LIB_FMODEX64)
# 		ENDIF (LIB_FMODEX)
# 
# 		# 32 BIT
# 		FIND_LIBRARY( LIB_FMODEVENT NAMES libfmodevent.so )
# 		IF (LIB_FMODEVENT)
# 		MESSAGE("FMODEVENT FOUND")
# 		MESSAGE(${LIB_FMODEVENT})
# 		add_definitions(-DENABLE_FMOD)
# 		SET(LIB_FMODLIBS ${LIB_FMODLIBS} ${LIB_FMODEVENT}) 
# 		ELSE (LIB_FMODEVENT)
# 			# 64 BIT
# 			FIND_LIBRARY( LIB_FMODEVENT64 NAMES libfmodevent64.so )
# 			IF (LIB_FMODEVENT64)
# 				MESSAGE("FMODEVENT FOUND")
# 				MESSAGE(${LIB_FMODEVENT64})
# 				add_definitions(-DENABLE_FMOD)
# 				SET(LIB_FMODLIBS ${LIB_FMODLIBS} ${LIB_FMODEVENT64}) 
# 			ELSE (LIB_FMODEVENT64)
# 				MESSAGE("FMODEVENT NOT FOUND")
# 			ENDIF (LIB_FMODEVENT64)
# 		ENDIF (LIB_FMODEVENT)
# 	ENDIF (DISABLE_FMOD)

	FIND_PACKAGE ( SDL REQUIRED )
	IF (SDL_FOUND)
	MESSAGE("SDL FOUND")
	MESSAGE(${SDL_LIBRARY})
	SET(bengine_LIBS ${bengine_LIBS} ${SDL_LIBRARY}) 
	Include_Directories (${SDL_INCLUDE_DIR})
	ELSE (SDL_FOUND)
	MESSAGE("SDL NOT FOUND")
	ENDIF (SDL_FOUND)

# 	FIND_PACKAGE ( SDL_image REQUIRED )
# 	IF (SDLIMAGE_FOUND)
# 	MESSAGE("SDLIMAGE FOUND")
# 	MESSAGE(${SDLIMAGE_LIBRARY})
# 	SET(bengine_LIBS ${bengine_LIBS} ${SDLIMAGE_LIBRARY}) 
# 	ELSE (SDLIMAGE_FOUND)
# 	MESSAGE("SDLIMAGE NOT FOUND")
# 	ENDIF (SDLIMAGE_FOUND)

# 		SET(Boost_USE_MULTITHREAD ON) #set a flag
# 		FIND_PACKAGE(Boost)
# # 		FIND_PACKAGE ( Boost COMPONENTS filesystem system REQUIRED)
# 		IF (Boost_FOUND)
# 			MESSAGE("BOOST FOUND")
# 			MESSAGE(${Boost_INCLUDE_DIRS})
# 			SET(bengine_INCLUDES ${bengine_INCLUDES} ${Boost_INCLUDE_DIRS}/boost) 
# # 			INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
# 			ADD_DEFINITIONS( " -lboost_thread" )
# 		ENDIF()
# 	FIND_PACKAGE ( Boost 1.4.3 COMPONENTS filesystem thread REQUIRED )
# 	IF (Boost_FOUND)
# 	MESSAGE("Boost FOUND")
# 	MESSAGE(${Boost_FILESYSTEM_LIBRARY} ${Boost_THREAD_LIBRARY})
# 	SET(bengine_LIBS ${bengine_LIBS} ${Boost_FILESYSTEM_LIBRARY} ${Boost_THREAD_LIBRARY}) 
# 	ELSE (Boost_FOUND)
# 	MESSAGE("Boost NOT FOUND")
# 	ENDIF (Boost_FOUND)


	find_package(Qt4 4.7 COMPONENTS QtCore QtGui QtOpenGL QtDeclarative REQUIRED )
	IF (QT_FOUND)
		MESSAGE("QT 4.7 FOUND")
		INCLUDE( ${QT_USE_FILE} ) # macro
		MESSAGE(${QT_LIBRARIES})
		SET(bengine_LIBS ${bengine_LIBS} ${QT_LIBRARIES}) 
	ELSE (QT_FOUND)
		MESSAGE(FATAL_ERROR "QT NOT FOUND")
	ENDIF (QT_FOUND)


		SET(Boost_USE_MULTITHREAD ON) #set a flag
# 		FIND_PACKAGE(Boost)
		FIND_PACKAGE ( Boost COMPONENTS filesystem system iostreams thread REQUIRED)
		IF (Boost_FOUND)
			MESSAGE("BOOST FOUND")
			MESSAGE(${Boost_INCLUDE_DIRS})
			SET(bengine_INCLUDES ${bengine_INCLUDES} ${Boost_INCLUDE_DIRS}/boost) 
# 			INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
# 			ADD_DEFINITIONS( " -lboost_thread -lboost_system" )
# 			ADD_DEFINITIONS(  )
			SET(bengine_LIBS ${bengine_LIBS} ${BOOST_LIBRARIES}) 
			SET(bengine_LIBS ${bengine_LIBS} "-lboost_system -lboost_iostreams") 
			
		ENDIF()

# 	FIND_PACKAGE ( SDL_net REQUIRED )
# 	IF (SDLNET_FOUND)
# 	MESSAGE("SDLNET FOUND")
# 	MESSAGE(${SDLNET_LIBRARY})
# 	SET(bengine_LIBS ${bengine_LIBS} ${SDLNET_LIBRARY}) 
# 	ELSE (SDLNET_FOUND)
# 	MESSAGE("SDLNET NOT FOUND")
# 	ENDIF (SDLNET_FOUND)

# 	FIND_PACKAGE ( PNG REQUIRED )
# 	IF (PNG_FOUND)
# 	MESSAGE("PNG FOUND")
# 	MESSAGE(${PNG_LIBRARY})
# 	SET(bengine_LIBS ${bengine_LIBS} ${PNG_LIBRARY}) 
# 	ELSE (PNG_FOUND)
# 	MESSAGE("PNG NOT FOUND")
# 	ENDIF (PNG_FOUND)

	FIND_PACKAGE ( Freetype REQUIRED )
	IF (FREETYPE_FOUND)
	MESSAGE("FREETYPE FOUND")
	MESSAGE(${FREETYPE_LIBRARY})
	SET(bengine_LIBS ${bengine_LIBS} ${FREETYPE_LIBRARY}) 
	SET(bengine_INCLUDES ${bengine_INCLUDES} ${FREETYPE_INCLUDE_DIRS}) 
	SET(bengine_INCLUDES ${bengine_INCLUDES} "${FREETYPE_INCLUDE_DIRS}/freetype2") 
	ELSE (FREETYPE_FOUND)
	MESSAGE("FREETYPE NOT FOUND")
	ENDIF (FREETYPE_FOUND)
ENDIF (UNIX)

	FIND_PACKAGE( OpenMP )
	if(OPENMP_FOUND)
	message("OPENMP FOUND")
# 	message("OPENMP LINKER")
# 	MESSAGE("${OpenMP_EXE_LINKER_FLAGS}")
# 	message("OPENMP CXX")
# 	MESSAGE("${OpenMP_CXX_FLAGS}")
	ADD_DEFINITIONS( ${OpenMP_CXX_FLAGS} )
# 	ADD_DEFINITIONS( " -lgomp" )
	SET(OpenMP_EXE_LINKER_FLAGS ${OpenMP_EXE_LINKER_FLAGS} "-lgomp")
	SET(bengine_LIBS ${bengine_LIBS} ${OpenMP_EXE_LINKER_FLAGS}) 
# 	set(bengine_LIBS ${bengine_LIBS} ${OpenMP_EXE_LINKER_FLAGS})
# 	set(bengine_INCLUDES ${bengine_INCLUDES} ${OpenMP_CXX_FLAGS})
# 	set(bengine_LIBS "${bengine_LIBS} ${OpenMP_EXE_LINKER_FLAGS}")
# 	SET(HAVE_OPENMP 1)
	add_definitions( -DHAVE_OPENMP=1 )
	ENDIF(OPENMP_FOUND)


# FIXME
# FIND_PACKAGE ( FTGL )
# IF (FTGL_FOUND)
#   MESSAGE("FTGL FOUND")
#   MESSAGE(${FTGL_LIBRARY})
#   SET(bengine_LIBS ${bengine_LIBS} ${FTGL_LIBRARY}) 
#   SET(bengine_LIBS ${bengine_LIBS} ${FTGL_LIBRARY}) 
#   SET(bengine_LIBS ${bengine_LIBS} ${FTGL_LIBRARY}) 
# ELSE (FTGL_FOUND)
#   MESSAGE("FTGL NOT FOUND")
# ENDIF (FTGL_FOUND)

link_libraries (
   ${bengine_LIBS}
)
LINK_DIRECTORIES (
   ${bengine_LIBS_DIRS} 
)

SET(bengine_INCLUDES "${CMAKE_SOURCE_DIR};dependencies/bullet;dependencies/tinyxml;dependencies/;${FREETYPE_INCLUDE_DIRS};./${bengine_WIN32INCL}") 
# SET(bengine_INCLUDES "${CMAKE_SOURCE_DIR}/ ./ src/utils/bullet") 
#   MESSAGE(${bengine_INCLUDES})

# CMAKEDEMO_SOURCE_DIR
include_directories( ${bengine_INCLUDES} )

#find_package(KDE4 REQUIRED)

#add_definitions(${QT_DEFINITIONS} ${KDE4_DEFINITIONS})

#include(KDE4Defaults)

#include(MacroLibrary)

#include(ConvenienceLibs.cmake)

#include(ManualStuff.cmake)

#include(ConfigureChecks.cmake)

#include_directories(${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} )

add_subdirectory(src)


########### install files ###############

# install(FILES share/critterding/pixmaps/cd.bmp DESTINATION share/critterding/pixmaps/ )
# install(FILES share/critterding/font.ttf DESTINATION share/critterding/ )
# install(FILES share/critterding/settings.xml DESTINATION share/critterding/ )
# INSTALL(DIRECTORY share/critterding/maps DESTINATION share/critterding/ )
# INSTALL(DIRECTORY share/critterding/critter DESTINATION share/critterding/ )
# INSTALL(DIRECTORY share/critterding/food DESTINATION share/critterding/ )
# INSTALL(DIRECTORY share/critterding/pixmaps DESTINATION share/critterding/ )
# INSTALL(DIRECTORY share/critterding/shaders DESTINATION share/critterding/ )

INSTALL(DIRECTORY share/critterding DESTINATION share/ )

=== src/CMakeLists.txt ===
# include_directories(${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} )
include_directories( ${bengine_INCLUDES} )
# TARGET_LINK_LIBRARIES( critterding utils )

add_subdirectory(math)
add_subdirectory(gl)
add_subdirectory(scenes/critterding)
add_subdirectory(utils)
add_subdirectory(gui)
add_subdirectory(brainz)
# add_subdirectory(scenes/stuntcoureur)
add_subdirectory(graphics)
add_subdirectory(filesystem)
add_subdirectory(common)
add_subdirectory(net)
add_subdirectory(physics)
# add_subdirectory(thread)
add_subdirectory(kernel)
# add_subdirectory(input)
# add_subdirectory(virtual_machine)
# add_subdirectory(webcam)


set(critterding_SRCS scenes/critterding/critterding.cpp)
add_executable(critterding ${critterding_SRCS})
TARGET_LINK_LIBRARIES ( critterding sccritterding ${bengine_LIBS} ${bengine_WIN32LIBS})


# set(stuntcoureur_SRCS scenes/stuntcoureur/stuntcoureur.cpp)
# add_executable(stuntcoureur ${stuntcoureur_SRCS})
# TARGET_LINK_LIBRARIES ( stuntcoureur stscene collada14dom ${bengine_LIBS} ${bengine_WIN32LIBS})

install(TARGETS critterding DESTINATION bin)

=== src/brainz/CMakeLists.txt ===

#include_directories(${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} )


########### next target ###############

set(brainz_STAT_SRCS
    archneuronz.cpp
    archsynapse.cpp
    brainzarch.cpp
    brainz.cpp
    neuroninterz.cpp
    synapse.cpp)

add_library(brainz STATIC ${brainz_STAT_SRCS})


########### install files ###############




#original Makefile.am contents follow:

#INCLUDES = $(all_includes)
#METASOURCES = AUTO
#noinst_LTLIBRARIES = libbrainz.la
#libbrainz_la_LDFLAGS = -avoid-version -no-undefined
#noinst_HEADERS =	archneuronz.h \
#			archsynapse.h \
#			brainzarch.h \
#			brainz.h \
#			neuroninterz.h \
#			synapse.h
#libbrainz_la_SOURCES =	archneuronz.cpp \
#			archsynapse.cpp \
#			brainzarch.cpp \
#			brainz.cpp \
#			neuroninterz.cpp \
#			synapse.cpp
#libbrainz_la_LIBADD = $(top_builddir)/src/utils/libutils.la

=== src/common/CMakeLists.txt ===
include_directories( ${bengine_INCLUDES} )

#include_directories(${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} )

# add_subdirectory(ftgl)
# add_subdirectory(bullet)


########### next target ###############

set(common_STAT_SRCS
    be_image.cpp
    be_obj_loader.cpp
    be_parser.cpp
    be_physics_debug_renderer.cpp
    be_mouse_picker.cpp
    be_rand.cpp
    be_model_system.cpp
    be_event_system.cpp
    be_command_system.cpp
    be_scene_node.cpp
    be_xml_helper.h
)

add_library(common STATIC ${common_STAT_SRCS})
target_link_libraries( common physics graphics )

=== src/filesystem/CMakeLists.txt ===
include_directories( ${bengine_INCLUDES} )

set(filesystem_STAT_SRCS
    be_file.cpp
    be_filesystem.cpp
    be_rootpaths.cpp
    be_dir.cpp
)

add_library(filesystem STATIC ${filesystem_STAT_SRCS})
target_link_libraries( filesystem boost_filesystem )

=== src/gl/CMakeLists.txt ===
include_directories( ${bengine_INCLUDES} )

#include_directories(${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} )


########### next target ###############

set(gl_STAT_SRCS glwindow.cpp)

add_library(gl STATIC ${gl_STAT_SRCS})
TARGET_LINK_LIBRARIES ( gl utils kernel )

########### install files ###############




#original Makefile.am contents follow:

#INCLUDES = $(all_includes) -I../utils/bullet 
#METASOURCES = AUTO
#libgl_la_LDFLAGS = -avoid-version -no-undefined
#noinst_LTLIBRARIES = libgl.la
#noinst_HEADERS = glwindow.h glscene.h
#libgl_la_SOURCES = glwindow.cpp glscene.cpp
#
#libgl_la_LIBADD = -L/usr/lib

=== src/graphics/CMakeLists.txt ===
include_directories( ${bengine_INCLUDES} )

set(gl_STAT_SRCS 
	be_graphics_kernel.cpp
	be_texture.cpp
	be_framebuffer.cpp
	be_buffer.cpp
	be_vertex_array.cpp
	be_shader.cpp
	be_mesh.cpp
	be_graphics_system.cpp
	be_camera.cpp
	be_color.cpp
	sc_graphics.cpp
)

add_library(graphics STATIC ${gl_STAT_SRCS})
target_link_libraries( graphics gl glew utils common math )

=== src/gui/CMakeLists.txt ===
include_directories( ${bengine_INCLUDES} )

########### next target ###############

set(gui_STAT_SRCS
    widget.cpp
    container.cpp
    canvas.cpp
    text.cpp
    text_uintp.cpp
    panel.cpp
    settingspanel.cpp
    enginesettingspanel.cpp
    button.cpp
    checkbox.cpp
    textprinter.cpp
    exitpanel.cpp
    logbuffermessage.cpp
    textinput.cpp
)

add_library(gui STATIC ${gui_STAT_SRCS})

TARGET_LINK_LIBRARIES ( gui filesystem ftgl math )
########### install files ###############




#original Makefile.am contents follow:

#INCLUDES = $(all_includes) -I../utils/bullet 
#METASOURCES = AUTO
#noinst_LTLIBRARIES = libgui.la
#noinst_HEADERS =	widget.h \
#			container.h \
#			canvas.h \
#			text.h \
#			text_uintp.h \
#			panel.h \
#			settingspanel.h \
#			enginesettingspanel.h \
#			button.h \
#			checkbox.h \
#			textprinter.h \
#			exitpanel.h \
#			logbuffermessage.h
#
#libgui_la_SOURCES = 	widget.cpp \
#			container.cpp \
#			canvas.cpp \
#			text.cpp \
#			text_uintp.cpp \
#			panel.cpp \
#			settingspanel.cpp \
#			enginesettingspanel.cpp \
#			button.cpp \
#			checkbox.cpp \
#			textprinter.cpp \
#			exitpanel.cpp \
#			logbuffermessage.cpp
#
#libgui_la_LIBADD =	$(top_builddir)/src/utils/libutils.la \
#			$(top_builddir)/src/math/libmath.la

=== src/kernel/CMakeLists.txt ===
include_directories( ${bengine_INCLUDES} )

set(kernel_STAT_SRCS
    be_log.cpp
)

add_library(kernel STATIC ${kernel_STAT_SRCS})
target_link_libraries( kernel )

=== src/math/CMakeLists.txt ===

#include_directories(${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} )


########### next target ###############

set(math_STAT_SRCS vector3f.cpp vector2i.cpp vector2f.cpp)

add_library(math STATIC ${math_STAT_SRCS})


########### install files ###############




#original Makefile.am contents follow:

#INCLUDES = $(all_includes)
#METASOURCES = AUTO
#noinst_LTLIBRARIES = libmath.la
#noinst_HEADERS =	vector3f.h \
#			vector2i.h \
#			vector2f.h
#libmath_la_SOURCES =	vector3f.cpp \
#			vector2i.cpp \
#			vector2f.cpp

=== src/net/CMakeLists.txt ===
include_directories( ${bengine_INCLUDES} )

set(net_STAT_SRCS 
# 	be_net_system.cpp
# 	be_socket_udp.cpp
# 	be_socket_udp_client.cpp
# 	be_socket_udp_server.cpp
# 	be_socket_tcp.cpp
# 	be_socket_tcp_client.cpp
# 	be_socket_tcp_server.cpp
	be_net_message.cpp
# 	be_socket_local.cpp
)

# enable_unity_build(be_net, net_STAT_SRCS)
add_library(be_net STATIC ${net_STAT_SRCS})
target_link_libraries( be_net kernel )

=== src/physics/CMakeLists.txt ===
include_directories( ${bengine_INCLUDES} )

set(physics_STAT_SRCS 
	be_physics_system.cpp
	be_raycast.cpp
# 	be_physics_material_loader.cpp
)

add_library(physics STATIC ${physics_STAT_SRCS})
target_link_libraries( physics graphics BulletSoftBody BulletDynamics BulletCollision LinearMath )
#  LinearMath BulletDynamics BulletCollision BulletSoftBody BulletMultiThreaded

# bulletmultithreaded, bulletsoftbody, bulletdynamics, bulletcollision, linearmath
# BulletMultiThreaded BulletSoftBody BulletDynamics BulletCollision LinearMath

## critterding 1.0-beta12.1

=== debian/changelog ===
critterding (1.0-beta12.1-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fixing FTBFS on GCC 6. (Closes: 811621)

 -- Breno Leitao <brenohl@br.ibm.com>  Sun, 17 Jul 2016 16:46:12 -0400

critterding (1.0-beta12.1-1.2) unstable; urgency=low

  [ Cyril Brulebois ]
  * Non-maintainer upload.
  * Fix FTBFS with gcc 4.7 due to missing <unistd.h> include (Closes: #667143).

 -- Jonathan Wiltshire <jmw@debian.org>  Sun, 13 May 2012 15:38:27 +0100

critterding (1.0-beta12.1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "FTBFS: BulletSoftBody/btSoftBodyInternals.h:175:17: error:
    uninitialized const 'zerodummy' [-fpermissive]":
    add patches from Ubuntu / Daniel T Chen:
    - 10uninitialized_constant
    - 11const_cast
    Fixes FTBFS. (LP: #770902) (Closes: #624965)
            
 -- gregor herrmann <gregoa@debian.org>  Sun, 23 Oct 2011 16:18:07 +0200

critterding (1.0-beta12.1-1) unstable; urgency=low

  * New upstream release.
  * Verdana fonts replaced with DejaVuSans fonts.
    - Removed patch 01nonfreefonts.
    - Removed +dfsg from version number.
    - Removed ttf-liberation dependency.
  * Removed patch 00libftgl, now it builds against system ftgl.
  * Added patch 00fontandiconpath to replace font and icon relative paths with
    absolute ones.

 -- Gabriele Giacone <1o5g4r8o@gmail.com>  Thu, 18 Mar 2010 02:03:17 +0100

critterding (1.0-beta11+dfsg-2) unstable; urgency=low

  * Added upstream README (Closes: #568698)
  * Added menu/desktop icons
  * Added ttf-liberation as runtime dependency (Closes: #568764)

 -- Gabriele Giacone <1o5g4r8o@gmail.com>  Sun, 07 Feb 2010 17:51:39 +0100

critterding (1.0-beta11+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #565472)

 -- Gabriele Giacone <1o5g4r8o@gmail.com>  Sat, 23 Jan 2010 04:14:14 +0100

=== debian/control ===
Source: critterding
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gabriele Giacone <1o5g4r8o@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), autotools-dev, automake, libtool,
 pkg-config, mesa-common-dev, libglu1-mesa-dev, libsdl1.2-dev, libftgl-dev,
 imagemagick
Standards-Version: 3.8.4
DM-Upload-Allowed: yes
Vcs-Git: git://git.debian.org/debian-science/packages/critterding.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/critterding.git
Homepage: http://critterding.sourceforge.net/

Package: critterding
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Evolving Artificial Life
 Critterding is a "Petri dish" universe in 3D that demonstrates
 evolving artificial life. Critters start out with completely
 random brains and bodies, but will automatically start evolving
 into something with much better survival skills.

=== debian/rules ===
#!/usr/bin/make -f

VERSION := $(shell dpkg-parsechangelog|sed -n '/^Version/{s/Version: \(.*\)-[0-9]*$$/\1/;s/+dfsg//p}')

%:
	dh  $@

override_dh_auto_build:
	autoreconf -fi
	./configure --prefix=/usr

override_dh_auto_install:
	dh_auto_install
	# icons
	mkdir $(CURDIR)/debian/icons && cd $(CURDIR)/debian/icons && mkdir 16 22 48
	convert $(CURDIR)/debian/critterding.png -scale 16x16 $(CURDIR)/debian/icons/16/critterding.png
	convert $(CURDIR)/debian/critterding.png -scale 22x22 $(CURDIR)/debian/icons/22/critterding.png
	convert $(CURDIR)/debian/critterding.png -scale 48x48 $(CURDIR)/debian/icons/48/critterding.png
	convert $(CURDIR)/debian/critterding.png -scale 32x32 $(CURDIR)/debian/icons/critterding.xpm

override_dh_auto_clean:
	[ ! -f Makefile ] || $(MAKE) distclean
	find . -name Makefile.in -delete
	rm -f aclocal.m4 config.* configure depcomp install-sh ltmain.sh missing
	rm -rf m4 src/utils/ftgl/.deps src/utils/ftgl/Makefile 
	rm -rf $(CURDIR)/debian/icons

get-orig-source:
	uscan --verbose --download-version $(VERSION) \
		--force-download --repack --no-symlink --rename

## critterding 1.0-beta12.1+dfsg

=== debian/changelog ===
critterding (1.0-beta12.1+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Gabriele Giacone ]
  * Repacking:
    + Remove embedded bullet, glew, tinyxml and ftgl libraries from tarball.
    + Add patch to use system libraries instead of embedded ones.
    + Readd +dfsg suffix to version.
  * Remove DMUA flag.
  * Fix d/copyright according to format specification 1.0.

  [ Andreas Tille ]
  * Fix Vcs fields
  * Exclude beta14 from watch file since its known to fail at startup
    (see bug #756997 for the package in experimental)
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Secure URI in copyright format (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Do not parse d/changelog (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * debian/copyright: Replace commas with whitespace to separate items in Files
    paragraph.
  * Use secure URI in Homepage field.
  * watch file standard 4 (routine-update)
  * Remove debian/critterding.menu (since we have critterding.desktop)
  * Remove code copy of ftgl
  * Trust dh_auto_configure
    Closes: #929586
  * Fix bashism
    Closes: #998789
  * Enable hardening options
  * Add myself as Uploader
    Closes: #856739
  * Fix clean target
    Closes: #1044933

 -- Andreas Tille <tille@debian.org>  Fri, 06 Sep 2024 22:21:52 +0200

=== debian/control ===
Source: critterding
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               pkgconf,
               mesa-common-dev,
               libglu1-mesa-dev,
               libsdl1.2-dev,
               libftgl-dev,
               imagemagick
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/critterding
Vcs-Git: https://salsa.debian.org/science-team/critterding.git
Homepage: https://critterding.sourceforge.net/
Rules-Requires-Root: no

Package: critterding
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Evolving Artificial Life
 Critterding is a "Petri dish" universe in 3D that demonstrates
 evolving artificial life. Critters start out with completely
 random brains and bodies, but will automatically start evolving
 into something with much better survival skills.

=== debian/rules ===
--- 
+++ 
@@ -1,13 +1,12 @@
 #!/usr/bin/make -f
 
-VERSION := $(shell dpkg-parsechangelog|sed -n '/^Version/{s/Version: \(.*\)-[0-9]*$$/\1/;s/+dfsg//p}')
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 %:
 	dh  $@
 
-override_dh_auto_build:
-	autoreconf -fi
-	./configure --prefix=/usr
+override_dh_auto_configure:
+	dh_auto_configure -- --enable-system-ftgl
 
 override_dh_auto_install:
 	dh_auto_install
@@ -22,10 +21,4 @@
 	[ ! -f Makefile ] || $(MAKE) distclean
 	find . -name Makefile.in -delete
 	rm -f aclocal.m4 config.* configure depcomp install-sh ltmain.sh missing
-	rm -rf m4 src/utils/ftgl/.deps src/utils/ftgl/Makefile 
 	rm -rf $(CURDIR)/debian/icons
-
-get-orig-source:
-	uscan --verbose --download-version $(VERSION) \
-		--force-download --repack --no-symlink --rename
-

=== debian/watch ===
version=4
opts="dversionmangle=auto,repacksuffix=+dfsg,uversionmangle=s/^/1.0-/;s/beta14/beta0/;s/beta13/beta0/" \
http://sf.net/critterding/critterding-(.*).tar.bz2

## critterding 1.0-beta14%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -1,12 +1,10 @@
 #!/usr/bin/make -f
 
-export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+VERSION := $(shell dpkg-parsechangelog|sed -n '/^Version/{s/Version: \(.*\)-[0-9]*$$/\1/;s/+dfsg//p}')
+DVERSION:= $(VERSION)+dfsg
 
 %:
-	dh  $@
-
-override_dh_auto_configure:
-	dh_auto_configure -- --enable-system-ftgl
+	dh $@ --parallel
 
 override_dh_auto_install:
 	dh_auto_install
@@ -17,8 +15,28 @@
 	convert $(CURDIR)/debian/critterding.png -scale 48x48 $(CURDIR)/debian/icons/48/critterding.png
 	convert $(CURDIR)/debian/critterding.png -scale 32x32 $(CURDIR)/debian/icons/critterding.xpm
 
+override_dh_strip:
+	dh_strip --dbg-package=critterding-dbg
+
 override_dh_auto_clean:
 	[ ! -f Makefile ] || $(MAKE) distclean
 	find . -name Makefile.in -delete
 	rm -f aclocal.m4 config.* configure depcomp install-sh ltmain.sh missing
-	rm -rf $(CURDIR)/debian/icons
+	rm -rf m4 src/utils/ftgl/.deps src/utils/ftgl/Makefile 
+	rm -rf $(CURDIR)/debian/icons obj-*
+
+TMPDIR=get-orig-source-tmp
+EMBEDLIBS=dependencies/bullet dependencies/glew dependencies/tinyxml src/utils/ftgl
+TXZ=critterding_$(DVERSION).orig.tar.xz
+get-orig-source:
+	mkdir -p $(TMPDIR)
+	uscan --verbose --download-version $(VERSION) --force-download \
+		--destdir $(TMPDIR) --rename
+	tar jxf $(TMPDIR)/*.bz2 -C $(TMPDIR); rm -f $(TMPDIR)/*.bz2
+	@echo "\nFollowing paths contain embedded libraries, removing from tarball:"
+	@cd $(TMPDIR)/*/ && for path in $(EMBEDLIBS); do \
+		echo $$path; rm -rf $$path; \
+        done
+	@echo Generating tarball...
+	cd $(TMPDIR) && tar -Jcf ../../$(TXZ) *
+	rm -rf $(TMPDIR)

## critterding 1.0-beta14+dfsg

=== debian/changelog ===
critterding (1.0-beta14+dfsg-2) experimental; urgency=medium

  * Fix {,-common} package split (Closes: #767855).

 -- Gabriele Giacone <1o5g4r8o@gmail.com>  Mon, 03 Nov 2014 00:57:06 +0100

critterding (1.0-beta14+dfsg-1) experimental; urgency=low

  * New upstream release.
  * Repacking:
    + Remove embedded bullet, glew, tinyxml and ftgl libraries from tarball.
    + Add patch to use system libraries instead of embedded ones.
    + Add libbullet-dev, libglew-dev and libtinyxml-dev as B-D.
    + Readd +dfsg suffix to version.
  * Add -common arch:all package. Move arch-indep files.
  * Add -dbg binary package with debug symbols.
  * Make VCS-* fields canonical.
  * Bump Standards-Version to 3.9.5 (no changes).
  * Add cmake, libqt4-opengl-dev, libboost-{thread,filesystem,iostreams}-dev,
    libsdl-image1.2-dev to B-D.
  * Remove DMUA flag.
  * Add parallel building support.
  * Fix d/copyright according to format specification 1.0.
  * Bump debhelper compatibility to 9.
  * Switch source and binaries compression to xz.

 -- Gabriele Giacone <1o5g4r8o@gmail.com>  Mon, 04 Aug 2014 11:41:30 +0200

=== debian/control ===
Source: critterding
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gabriele Giacone <1o5g4r8o@gmail.com>
Build-Depends: debhelper (>= 9), autotools-dev, automake, libtool,
 pkg-config, mesa-common-dev, libglu1-mesa-dev, libsdl1.2-dev, libftgl-dev,
 imagemagick, cmake, libqt4-opengl-dev, libboost-thread-dev,
 libboost-filesystem-dev, libboost-iostreams-dev, libsdl-image1.2-dev,
 libbullet-dev, libtinyxml-dev, libglew-dev
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/debian-science/packages/critterding.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/critterding.git
Homepage: http://critterding.sourceforge.net/

Package: critterding
Architecture: any
Depends: critterding-common (= ${source:Version}), ${shlibs:Depends},
 ${misc:Depends}
Description: Evolving Artificial Life
 Critterding is a "Petri dish" universe in 3D that demonstrates
 evolving artificial life. Critters start out with completely
 random brains and bodies, but will automatically start evolving
 into something with much better survival skills.

Package: critterding-common
Architecture: all
Depends: ${misc:Depends}
Replaces: critterding (<< 1.0-beta14+dfsg-1)
Breaks: critterding (<< 1.0-beta14+dfsg-1)
Description: Evolving Artificial Life - architecture-independent files
 Critterding is a "Petri dish" universe in 3D that demonstrates
 evolving artificial life. Critters start out with completely
 random brains and bodies, but will automatically start evolving
 into something with much better survival skills.
 .
 This package includes architecture-independent files.

Package: critterding-dbg
Section: debug
Architecture: any
Depends: critterding (= ${binary:Version}), ${misc:Depends}
Description: Evolving Artificial Life - debug symbols
 Critterding is a "Petri dish" universe in 3D that demonstrates
 evolving artificial life. Critters start out with completely
 random brains and bodies, but will automatically start evolving
 into something with much better survival skills.
 .
 This package includes debug symbols for critterding.
